<?php
/*
 *Plugin Name: SmilePayC2C(UN-PAY)
 *Description: SmilePay 7-11 c2c Shipping
 * Version: 2.6.7
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
*/
 
/**
 * Check if WooCommerce is active
 */
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action('plugins_loaded', 'smilepayc2cu_shipping_method_init', 0);

    add_action('woocommerce_checkout_update_order_review','Smilepayc2cup_shipping_method_match');
    add_action('before_woocommerce_pay','Smilepayc2cup_shipping_method_match_orderpay');

    //te覡LoIڤ覡
    function Smilepayc2cup_shipping_method_match()
    {

        $packages = WC()->cart->get_shipping_packages();
      

        foreach ( $packages as $package_key => $package ) 
        {
            WC()->shipping()->load_shipping_methods( $package );
           
        }
        $shipping_methods =  WC()->shipping()->shipping_methods;
        $payment_gateways = WC()->payment_gateways();



        foreach($shipping_methods as $shipping_method)
        {
           if( $shipping_method->id == 'smilepay_711_c2c_shippingunpay' && $shipping_method->get_instance_id() != 0)
           {
               $smilepay_c2cup_shipping_method =  $shipping_method;
            
               break;
           }
           
        }
        if( isset($smilepay_c2cup_shipping_method) &&  $smilepay_c2cup_shipping_method)
        {
            if($smilepay_c2cup_shipping_method->enabled!="yes")
                return;
            if($smilepay_c2cup_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                return;
           
        }
        

        if(isset($_REQUEST['shipping_method'][0] ))
            $selected_shipping_method = $_REQUEST['shipping_method'][0] ;
        else
        {
            $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
            if(empty($chosen_methods))
                return;
            $selected_shipping_method = $chosen_methods[0]; 
        }
                
        foreach ( $payment_gateways as $payment_gateway ) {
             foreach ( $payment_gateway as $gateway ) {
                    if(strtolower($selected_shipping_method) == 'smilepay_711_c2c_shippingunpay')
                    {
               
                        if(!in_array($gateway->id, $smilepay_c2cup_shipping_method->filter_payment) )
                            $gateway->enabled = 'no';
                    }
                   

             }
        }
    
         
      
    }
    //te覡LoIڤ覡 b
    function Smilepayc2cup_shipping_method_match_orderpay()
    {
        global $wp;

        if ( isset( $_GET['pay_for_order']) && $_GET['pay_for_order'] == 'true') 
        {
            $order_id = $wp->query_vars['order-pay'];
           
            if($order_id)
            {
                $order = wc_get_order( $order_id ); 
                if(!$order)
                    return;
                //$packages = WC()->cart->get_shipping_packages();
                
                //make fake package for find shipping region
                $packages = array();
                $packages[0]['destination']['country']   =  $order->shipping_country;
			    $packages[0]['destination']['state']     =  $order->shipping_state;
			    $packages[0]['destination']['postcode']  =  $order->shipping_postcode;
			    $packages[0]['destination']['city']      =  $order->shipping_city;
			    $packages[0]['destination']['address']   =  $order->shipping_address_1;
			    $packages[0]['destination']['address_2'] =  $order->shipping_address_2;

              
               
                //load shipping method
                foreach ( $packages as $package_key => $package ) 
                {
                     WC()->shipping()->load_shipping_methods( $package );
                }

              
                $shipping_methods =  WC()->shipping()->shipping_methods;
                $payment_gateways = WC()->payment_gateways();
                
                    
                foreach($shipping_methods as $shipping_method)
                {

                    if( $shipping_method->id == 'smilepay_711_c2c_shippingunpay' && $shipping_method->get_instance_id() != 0)
                    {
                        $smilepay_c2cup_shipping_method =  $shipping_method;
                        break;
                    }
                }

                if( isset($smilepay_c2cup_shipping_method) &&  $smilepay_c2cup_shipping_method)
                {
                    if($smilepay_c2cup_shipping_method->enabled!="yes")
                        return;
                    if($smilepay_c2cup_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                        return;
                }
         
                $selected_shipping_method =    $order->has_shipping_method('smilepay_711_c2c_shippingunpay');

                
                foreach ( $payment_gateways as $payment_gateway ) {
                    foreach ( $payment_gateway as $gateway ) {
                        if($selected_shipping_method)
                        {
               
                             if(!in_array($gateway->id, $smilepay_c2cup_shipping_method->filter_payment) )
                                 $gateway->enabled = 'no';
                        }
                      

                    }
                }


            }
            else
                return;



        }
    }


	function  smilepayc2cu_shipping_method_init() {
		if ( ! class_exists( 'WC_Smilepayc2cu_Shipping_Method' ) ) {
            
			class WC_Smilepayc2cu_Shipping_Method extends WC_Shipping_Method {
                var $filter_payment;

				public function __construct($instance_id = 0) {
					$this->id                 = 'smilepay_711_c2c_shippingunpay';
					$this->method_title       = __( 'SmilePay 7-11 Shipping(UN-PAY)' ); 

                    //for woocommerce 2.6 modify
					//$this->enabled            = "yes";
                    $this->instance_id 			 = absint( $instance_id );
                    $this->supports              = array(
			                                        'shipping-zones',
			                                        'instance-settings',
			                                        'instance-settings-modal',
		                                            );
                    $this->method_description    = u2bcu('7-11Wӯ¨f');


					
                 
					$this->init();
                    if(isset( $this->instance_settings['title']))
                        $this->title = $this->instance_settings['title'];
                    else
                         $this->title = u2bcu('SmilePay 7-11Wӯ¨f');
                    $this->filter_payment = array(
                                            'smilepayatm',
                                            'smilepaycredit',
                                            'smilepaycsv',
                                            'smilepayfamiport',
                                            'smilepayibon',
                                            'smilepayunion',
                                        );

				}

				public function init_form_fields() {  //x]m
					
					//for woocommerce 2.6 modify
					//$this->form_fields = array(
                    $this->instance_form_fields = array(
						/*'enabled' => array(
							'title' => __(u2bcu("ҥ/"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
              'label' => __(u2bcu("SmilePay tRtWӯ¨f"), 'woocommerce'),
						),*/
                     'title' => array(
                                'title' => __(u2bcu('D'), 'woocommerce'),
                                'type' => 'text',
                                'description' => __(u2bcu('UȦbbɩܪte覡D'), 'woocommerce'),
                                'default' => __(u2bcu('SmilePay 7-11Wӯ¨f'), 'woocommerce')
                            ),
						'fee' => array(
							'title'       => __(u2bcu('O'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
						'fee_top' => array(
							'title'       => __(u2bcu('KBOe'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __(u2bcu("F즹BɡAKBOAϥνЫOť"), 'woocommerce'),
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                        'min_total' => array(
							'title'       => u2bcp('̧COB'),
							'type'        => 'price',
							'description' => u2bcp('qBF즹]wBA~iHϥΦte覡AtBO'),
							'default'     => '',
						),		
                        'payment_filter_enabled' => array(
							'title' =>  u2bcu("SmilePay te覡ftIڤ覡Wh"),
                            'description' => __(u2bcu("}Ҧ\AbbɡAte覡O¨fAIڤ覡utRtyҲ"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' => u2bcu("ҥ"),
						),	
                        	//mobile map start
                      /*  'mobile_map' => array(
							'title'       => __(u2bcu('ҥΤOf'), 'woocommerce' ),
							'type'        => 'checkbox',
							'description' => __(u2bcu("P_O̬OϥΤɡAܤa"), 'woocommerce'),
							'desc_tip'    => true,
						),	*/
                        //mobile map end
						'hiddtext' => array(
							'title' => __(u2bcu('Wӯ¨f`Nƶ'), 'woocommerce'),
							'type' => 'hidden',
							'description' => __(u2bcu("ϥζWӯ¨f\Aݪ`NHUƶG
														<br><font color='red'>ҲնȤ䴩SmilePaytRtyڨϥ</font>							
														<br>1.ХSmilePayӮax}Ҩf\*<a target='_blank' href='http://www.smilepay.net/RVG.ASP'>Ӯax</a>*
														<br>2.bT<font color='red'>pq</font><font color='red'>X</font>Aӫ~ɷ|H²TqC
														<br>3.O̦߭qAiSmilePayӮaxo<font color='red'>fKNX</font>C
														<br>4.O̦߭qAiܭqƵI<font color='red'>}úO</font>C														
														<br>5.бN<font color='red'>fKNX</font>ʷsWܰӫ~ƵAHQO̬dߪyAC
														<br>6.hаѾ\A<font color='red'>SmilePay</font>P<font color='red'>WooCommerceҲջ</font>C
														"), 'woocommerce'),
							'default' => __('', 'woocommerce')
						)         
					);
				}
 
				function init() {
					$this->init_form_fields(); 
					$this->init_settings();
					$this->fee= $this->get_option( 'fee' );
					$this->fee_top= $this->get_option( 'fee_top' );	
                    $this->min_total =$this->get_option('min_total');				
					add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
					
				}
 
				/**
				 * calculate_shipping function.
				 *
				 * @access public
				 * @param mixed $package
				 * @return void
				 */
				public function calculate_shipping( $package = array() ) {
					$shipping_total=0;
					$shipping_total=$this->fee;
					
					$fee_top=$this->fee_top;
					$total = WC()->cart->cart_contents_total;					
					if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					{$shipping_total=0;}
					
					$rate = array(
						'id' => $this->id,
						'label' => $this->title,
						'cost' => $shipping_total
					);
                    if($total < $this->min_total)
                        return;
					// Register the rate
					$this->add_rate( $rate );
				}
                // O_C2CUPBe
                // $order_id:qs
                public function isSelectedSmilepayC2Cup($order_id)
                {
                 
                    if(!isset($order_id) || empty($order_id))
                    {
                        return false;
                    }
            
                    $order = new WC_Order($order_id);
          
                    if(!isset($order) || empty($order))
                        return false;

                    if(is_admin())
                    {
                        $shipping_methods = $order->get_shipping_methods();
		                $has_method = false;

		                if ( empty( $shipping_methods ) ) {
			                return false;
		                }
                         

		                foreach ( $shipping_methods as $shipping_method ) {

                            foreach($shipping_method['item_meta_array'] as $shipping_method_i  )
                            {
                            
                                if ( $shipping_method_i->key == 'method_id' && $shipping_method_i->value == $this->id ) {
				                    return true;
			                    }   
                            }
			                
		                }
                        return FALSE;

                    }
                    else
                    {

                        if( $order->has_shipping_method($this->id ))
                            return true;
                        else
                            return false;
                    }
                 }
 
			}
		}
        if(is_admin())
        {
            global $pagenow;
            add_action('admin_notices', 'smilepay_c2cup_shipping_error_show' );
            if($pagenow=='post.php' && $_GET['Page']=='smilepay_c2cup_shipping_gen')
            {
                smilepay_c2cup_shipping_gen();
            }
        }
	}

  
	add_action( 'woocommerce_shipping_init', 'smilepayc2cu_shipping_method_init' );
 
	function add_smilepayc2cu_shipping_method( $methods ) {

        //for woocommerce 2.6 modify
		$methods['smilepay_711_c2c_shippingunpay'] = 'WC_Smilepayc2cu_Shipping_Method';
		return $methods;
	}

    
    function smilepay_c2cup_shipping_error_show()
    {
        $error="";
        if(isset($_COOKIE['smilepay_c2cup_admin_shipping_error']))
        {
	     $error= $_COOKIE['smilepay_c2cup_admin_shipping_error'];
             unset($_COOKIE['smilepay_c2cup_admin_shipping_error']);
             setcookie('smilepay_c2cup_admin_shipping_error', '', time() - 30 );
        }
            
        if($error)
        {
            echo "<div class='notice notice-error'><p>$error</p></div>";
        }

    }

    function smilepay_c2cup_shipping_gen()
    {
        
        if(
            !isset($_GET['smseid'])  || !$_GET['smseid'] ||
            !isset($_GET['dcvc'])  || !$_GET['dcvc'] ||
            !isset($_GET['Verify_key'])  || !$_GET['Verify_key'] ||
            !isset($_GET['order_id'])  || !$_GET['order_id'] 
        )
        {
            setcookie("smilepay_c2cup_admin_shipping_error",  u2bcu("~,Ѽƿ~"), time()+30);
            wp_redirect($order_url);
            exit;
        }

        $order_id = $_GET['order_id'];
        $order_url =  get_admin_url()."post.php?post=$order_id&action=edit";
       
       // if(!class_exists('WC_Smilepayc2cu_Shipping_Method'))
         //   smilepayc2cu_shipping_method_init();
        $smilepayc2cup_obj=new WC_Smilepayc2cu_Shipping_Method();
        if(! $smilepayc2cup_obj->isSelectedSmilepayC2Cup($order_id))
        {
          
            setcookie("smilepay_c2cup_admin_shipping_error",  u2bcu("~,ӭq"), time()+30);
            wp_redirect($order_url);
            exit;
            
        }

      


        $cccurl="https://ssl.smse.com.tw/api/C2CPaymentU.asp";
        $postdata="types=xml&smseid=".$_GET['smseid']."&dcvc=".$_GET['dcvc']."&Verify_key=".$_GET['Verify_key'];

        $ch1 = curl_init();
	    curl_setopt($ch1, CURLOPT_URL, $cccurl);
	    curl_setopt($ch1, CURLOPT_VERBOSE, 1);
	    curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, FALSE);
	    curl_setopt($ch1, CURLOPT_SSL_VERIFYHOST, FALSE);
	    curl_setopt($ch1, CURLOPT_POST, 1);
	    curl_setopt($ch1, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch1, CURLOPT_POSTFIELDS, $postdata);
	    $string_1 = curl_exec($ch1);
	    curl_close($ch1);
	    $xmls = simplexml_load_string($string_1);
	    $Status_1 = $xmls->Status;

        if( empty($xmls))
        {
            setcookie("smilepay_c2cup_admin_shipping_error", u2bcu("~"), time()+30);
            wp_redirect($order_url);
            exit;
        }


	    if($Status_1=="1")
	    {
             $order = new WC_Order($order_id);

             $notes=$order->get_customer_order_notes();
        
             $comment = u2bcu("fKXG".$xmls->paymentno . $xmls->validationno."<br>*<a target='_blank' href='https://eservice.7-11.com.tw/E-Tracking/search.aspx'>d߭</a>*");
            
             foreach($notes as $note)
             {
                 if($note->comment_content == $comment)
                 {    
                    setcookie("smilepay_c2cup_admin_shipping_error", u2bcu("wg͸ӳƵ"), time()+30);
                    wp_redirect($order_url);
                    exit;
                   
                 }
                   

             }
           
             $order->add_order_note($comment,"1");
             wp_redirect($order_url);
             exit;
        }
        else
        {
            setcookie("smilepay_c2cup_admin_shipping_error", u2bcu(sprintf("~,~NX:%s,",$xmls->Status)), time()+30);
            wp_redirect($order_url);
            exit;
        }
      
    }
	add_filter( 'woocommerce_shipping_methods', 'add_smilepayc2cu_shipping_method' );
}


   



function u2bcu($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ucu($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
